#!/bin/env python
# -*- coding: UTF-8 -*-

import os
import re
import mensaje_aviso_crv
import pygtk
pygtk.require('2.0')
import gtk

#Clase para la gestion de listas de receptores conocidos
class Lista_Clientes:
	# Muestra el bloque completo de la lista
        def show(self):
                self.listado_fixed.show()

	# Oculta el bloque completo de la lista
        def hide(self):
                self.listado_fixed.show()

	def delete_event(self, widget, data = None):
                self.info_window.destroy()

        def destroy(self, widget, data = None):
                self.info_window.destroy()

	# Funcion encargada de leer el fichero de receptores conocidos y publicar la lista en 
	# la ventana principal de la aplicacion
        def get_lista_completa(self):
                self.listado.clear()
		fichero_lista = open('%slista_clientes.txt' % self.PATHLISTA, 'r')
		lista_completa = fichero_lista.readlines()
		for cliente in lista_completa: # Cada receptor se incluye en la lista
			datos_cliente = cliente.split(';;')
			print datos_cliente[3]
			if datos_cliente[3] == "True":
				print "conectado"
				self.listado.append([self.imagen_conectado,datos_cliente[1],datos_cliente[2],datos_cliente[0]])
			else:
				print "no conectado"
				self.listado.append([self.imagen_noconectado,datos_cliente[1],datos_cliente[2],datos_cliente[0]])
		fichero_lista.close()

	# Funcion asociada al boton Borrar de la ventana principal de la aplicacion encargada
	# de borrar el receptor seleccionado de la lista
	def borrar_cliente(self, widget, response_id, data = None):
		if response_id == -5: # La confirmacion se ha aceptado
			(model, fila_iterator) = self.seleccion_vista.get_selected()
			if fila_iterator != None: # Se ha seleccionado un elemento de la lista
				sel_mac = model.get_value(fila_iterator, 3)
				pattern = re.compile('%s' % sel_mac)
				f_lista = open('%slista_clientes.txt' % self.PATHLISTA, 'r')
				listado = f_lista.readlines()
				f_lista.close()
				f_lista = open('%slista_clientes.txt' % self.PATHLISTA, 'w')
				for elemento in listado: # Se busca el elemento en la lista y en caso de encontrarse no se guarda de nuevo
					if re.search(pattern, elemento) == None:
						f_lista.write(elemento)
				f_lista.close()
			self.get_lista_completa()
		widget.hide()

	# Funcion asociada al boton de Borrar todo de la ventana principal encargada de borrar
	# la lista completa de receptores conocidos
	def borrar_lista(self, widget, response_id, data = None):
		if response_id == -5: # La confirmacion se ha aceptado
			f_lista = open('%slista_clientes.txt' % self.PATHLISTA, 'w')
			f_lista.close()
			self.get_lista_completa()
		widget.hide()

	# Funcion asociada al boton de Aceptar de la ventana de informacion de receptor
	# Se encarga de aplicar los cambios realizados al receptor seleccionado
	def aplicar_cambio_cliente(self, widget, mac, ip):
		# se busca en el fichero de lista el receptor correspondiente
		pattern = re.compile('%s' % mac)
		f_lista = open('%slista_clientes.txt' % self.PATHLISTA, 'r')
		listado = f_lista.readlines()
		f_lista.close()
		f_lista = open('%slista_clientes.txt' % self.PATHLISTA, 'w')
		for elemento in listado:
			if re.search(pattern, elemento) != None:
				# se modifica el dato adecuado
				datos_cliente = elemento.split(';;')
				elemento = '%s;;%s;;%s;;%s;;\n' % (mac, ip, self.in_info.get_text(), datos_cliente[3])		
			f_lista.write(elemento)
		f_lista.close()
		self.info_window.destroy()
		self.get_lista_completa()

	# Funcion para la modificacion de los datos de un receptor conocido
	# Presenta una nueva ventana con los datos del receptor seleccionado
	# de la lista y los campos modificables
	def editar_cliente(self, widget, data = None):
		# Extraccion del receptor seleccionado de la lista
		(model, fila_iterator) = self.seleccion_vista.get_selected()
		if fila_iterator != None:
			sel_mac = model.get_value(fila_iterator, 3)
			sel_ip = model.get_value(fila_iterator, 1)
			sel_info = model.get_value(fila_iterator, 2)
		else: # Si no se selecciona uno se avisa por pantalla
			aviso = mensaje_aviso_crv.Mensaje_Aviso("No ha seleccionado un receptor de la lista de receptores conocidos. Vuelva a la ventana pricipal de la aplicación, seleccione un elemento de la lista y a continuación pulse sobre el botón \"Editar\" situado en la parte inferior de la ventana, para ver la información y modificar los datos del elemento seleccionado.")
			return 1
		
		# Se crea la ventana y el contenedor del cuadro de informacion
		self.info_window = gtk.Window(gtk.WINDOW_TOPLEVEL)
                self.info_window.set_position(gtk.WIN_POS_CENTER)
		self.info_window.set_keep_above(True)
                self.info_window.set_title("CRV - Información del receptor")
                self.info_window.set_icon_from_file('%simg/crv_icon.png' % self.PATH)
                self.info_window.set_border_width(10)
                self.info_window.set_resizable(False)
                self.info_window.connect("delete_event", self.delete_event)
                self.vbox = gtk.VBox(False, 30)
                self.panel = gtk.Fixed()
                self.vbox.pack_start(self.panel, True, True, 0)
                self.info_window.add(self.vbox)

                # Cabecera de la ventana
                self.imagen_aviso = gtk.Image()
                self.imagen_aviso.set_from_file('%simg/informacion.png' % self.PATH)
                self.panel.put(self.imagen_aviso, 130, 10)
                self.et_aviso = gtk.Label()
                self.et_aviso.set_markup("<b>Información del receptor</b>")
                self.et_aviso.set_use_markup(True)
                self.panel.put(self.et_aviso, 190, 25)

		# Informacion del receptor junto con los apartados modificables
		self.et_ip = gtk.Label()
                self.et_ip.set_markup("<b>Dirección IP:</b>  %s" % sel_ip)
                self.et_ip.set_use_markup(True)
                self.panel.put(self.et_ip, 10, 90)
		self.et_mac = gtk.Label()
                self.et_mac.set_markup("<b>Dirección MAC:</b>  %s" % sel_mac)
                self.et_mac.set_use_markup(True)
                self.panel.put(self.et_mac, 10, 120)
		self.et_info = gtk.Label()
                self.et_info.set_markup("<b>Información:</b>")
                self.et_info.set_use_markup(True)
                self.panel.put(self.et_info, 10, 160)
		self.in_info = gtk.Entry(20)
		self.in_info.set_size_request(200, 28)
		self.in_info.set_text(sel_info)
                self.panel.put(self.in_info, 120, 156)
		self.et_max = gtk.Label("(max. 20 caracteres)")
                self.panel.put(self.et_max, 330, 160)
		self.et_nota = gtk.Label()
                self.et_nota.set_markup("<i>Nota: es posible modificar la información adicional que se muestra por\ncada receptor conocido, esta información puede ayudar al profesorado\na identificar facilmente los ordenadores dentro del aula. Para introducir\nla información basta con escribirla en el cuadro de texto anterior y\npulsar sobre el botón \"Aceptar\" para guardar el cambio.</i>")
                self.et_nota.set_use_markup(True)
                self.panel.put(self.et_nota, 10, 200)

                # Botonera de la ventana
                self.boton_aceptar = gtk.Button("Aceptar")
                self.boton_aceptar.connect("clicked", self.aplicar_cambio_cliente, sel_mac, sel_ip)
                self.boton_aceptar.set_size_request(90,30)
                self.panel.put(self.boton_aceptar, 400, 300)
                self.boton_cancelar = gtk.Button("Cancelar")
                self.boton_cancelar.connect("clicked", self.delete_event)
                self.boton_cancelar.set_size_request(90,30)
                self.panel.put(self.boton_cancelar, 300, 300)

		# Dibujar la ventana
                self.info_window.set_size_request(500, 340)
                self.imagen_aviso.show()
                self.et_aviso.show()
		self.et_ip.show()
		self.et_mac.show()
		self.et_info.show()
		self.in_info.show()
		self.et_max.show()
		self.et_nota.show()
                self.boton_aceptar.show()
                self.boton_cancelar.show()
                self.panel.show()
                self.vbox.show()
                self.info_window.show()

		
	# Funcion que se encarga de actualizar el estado de un receptor de la lista
	# Paramentros de entrada:
	# - cliente: direccion MAC del cliente que se desea actualizar su estado
	# - nuevo estado: estado al que se desea actualizar
	#		  True: estado conectado
	#		  False: estado desconectado
	def actualizar_estado_cliente(self, cliente, nuevo_estado):
		#fila_iterator = self.listado.get_iter_first()
		# Buscar en la lista el cliente correcto
		#while fila_iterator != None:
		#	if cliente == self.listado.get_value(fila_iterator, 3):
		#		# Actualizar su estado
		#		if nuevo_estado == True:
		#			self.listado.set_value(fila_iterator, 0, self.imagen_conectado)
		#		else:
		#			self.listado.set_value(fila_iterator, 0, self.imagen_noconectado)
		#	fila_iterator = self.listado.iter_next(fila_iterator)
		fichero_lista = open('%slista_clientes.txt' % self.PATHLISTA, 'r')
		lista_completa = fichero_lista.readlines()
		fichero_lista.close()
		fichero_lista = open('%slista_clientes.txt' % self.PATHLISTA, 'w')
		
		for cliente in lista_completa: 
			datos_cliente = cliente.split(';;')
			if cliente == datos_cliente[0]:
				elemento = '%s;;%s;;%s;;%s;;\n' % (datos_cliente[0], datos_cliente[1], datos_cliente[2], nuevo_estado)
			fichero_lista.write(elemento)
		fichero_lista.close()

	# Funcion que devuelve la direccion IP del receptor seleccionado de la lista
	# Si no se selecciona un elemento se devuelve una cadena vacia
	def ip_fila_seleccionada(self):
		(model, fila_iterator) = self.seleccion_vista.get_selected()
		if fila_iterator != None:
			return model.get_value(fila_iterator, 1)
		return ''	

	# Funcion que devuelve la direccion MAC del receptor seleccionado de la lista
	# Si no se selecciona un elemento se devuelve una cadena vacia
	def mac_fila_seleccionada(self):
		(model, fila_iterator) = self.seleccion_vista.get_selected()
		if fila_iterator != None:
			return model.get_value(fila_iterator, 3)
		return ''

	# Funcion que devuelve el estado del receptor seleccionado de la lista
	# Si no se selecciona un elemento se devuelve una cadena vacia
	def estado_fila_seleccionada(self):
		(model, fila_iterator) = self.seleccion_vista.get_selected()
		if fila_iterator != None:
			ip = model.get_value(fila_iterator, 1)
			fichero_lista = open('%slista_clientes.txt' % self.PATHLISTA, 'r')
			lista_completa = fichero_lista.readlines()
			fichero_lista.close()
			for cliente in lista_completa:
				datos_cliente = cliente.split(';;')
				if datos_cliente[1] == ip:
					return datos_cliente[3]
		return False	

	# Funcion que actualiza la lista de receptores colocando su estado a desconectado
	def todos_desconectados(self):
		#fila_iterator = self.listado.get_iter_first()
		#while fila_iterator != None:
		#	self.listado.set_value(fila_iterator, 0, self.imagen_noconectado)
		#	fila_iterator = self.listado.iter_next(fila_iterator)
                #self.listado.clear()
		fichero_lista = open('%slista_clientes.txt' % self.PATHLISTA, 'r')
		lista_completa = fichero_lista.readlines()
		fichero_lista.close()
		fichero_lista = open('%slista_clientes.txt' % self.PATHLISTA, 'w')
		
		for cliente in lista_completa: 
			datos_cliente = cliente.split(';;')
			elemento = '%s;;%s;;%s;;False;;\n' % (datos_cliente[0], datos_cliente[1], datos_cliente[2])
			fichero_lista.write(elemento)
		fichero_lista.close()

	# Constructor de la clase
	# Se encarga de crear la lista a partir del fichero de receptores conocidos
	# Incluye la lista en la ventana principal de la aplicacion
        def __init__(self):
                self.PATH = '/usr/local/crv/'
		self.PATHLISTA = '/usr/share/crv/'

                self.imagen_conectado = gtk.gdk.pixbuf_new_from_file('%simg/conectado.png' % self.PATH)
                self.imagen_noconectado = gtk.gdk.pixbuf_new_from_file('%simg/noconectado.png' % self.PATH)

		# Se crea el contenedor de la lista
                self.listado_fixed = gtk.Fixed()
                self.listado_fixed.set_size_request(365, 420)
                self.et_lista = gtk.Label()
                self.et_lista.set_markup("<b>Receptores conocidos</b>")
                self.et_lista.set_use_markup(True)
                self.listado_fixed.put(self.et_lista, 0, 0)
                self.et_lista.show()
                self.contenedor_lista = gtk.ScrolledWindow()
                self.contenedor_lista.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
                self.contenedor_lista.set_shadow_type(gtk.SHADOW_IN)
                self.listado = gtk.ListStore(gtk.gdk.Pixbuf, str, str, str)
                self.get_lista_completa()
                self.vista_arbol_lista = gtk.TreeView()
                self.vista_arbol_lista.set_model(self.listado)

                # Columna de estado de la lista
                self.contenido_columna_estado = gtk.CellRendererPixbuf()
                self.columna_estado = gtk.TreeViewColumn('Estado', self.contenido_columna_estado, pixbuf=0)
                self.vista_arbol_lista.append_column(self.columna_estado)

                # Columna de direccion ip de la lista
                self.contenido_columna_dirip = gtk.CellRendererText()
                self.columna_dirip = gtk.TreeViewColumn('Dirección IP', self.contenido_columna_dirip, text=1)
                self.vista_arbol_lista.append_column(self.columna_dirip)

                # Columna de informacion de la lista
                self.contenido_columna_informacion = gtk.CellRendererText()
                self.columna_informacion = gtk.TreeViewColumn('Información', self.contenido_columna_informacion, text=2)
                self.vista_arbol_lista.append_column(self.columna_informacion)
                
                # Columna de MAC de la lista
                self.contenido_columna_mac = gtk.CellRendererText()
                self.columna_mac = gtk.TreeViewColumn('MAC', self.contenido_columna_mac, text=3)
                self.vista_arbol_lista.append_column(self.columna_mac)
		self.columna_mac.set_visible(False)
                
		# Configuracion de opciones de visibilidad de la lista
                self.seleccion_vista = self.vista_arbol_lista.get_selection()
                self.seleccion_vista.set_mode(gtk.SELECTION_SINGLE)

		# Dibujar la lista en la ventana principal
                self.listado_fixed.put(self.contenedor_lista, 0, 20)
                self.contenedor_lista.add(self.vista_arbol_lista)
                self.contenedor_lista.set_size_request(365, 420)
                self.contenedor_lista.show_all()
