#!/bin/env python
# -*- coding: UTF-8 -*-

#import os
#import re
#import string
#import grp
#import signal
#import time
import pygtk
pygtk.require('2.0')
import gtk

# Clase para la creacion y publicacion de mensajes de aviso por pantalla
class Mensaje_Aviso:
        def delete_event(self, widget, data = None):
                self.warning_window.destroy()

        def destroy(self, widget, data = None):
                self.warning_window.destroy()

	# Funcion encargada de preparar el mensaje que se publicara
	# Se devuelve el numero de lineas que tiene el mensaje
        def preparar_mensaje(self):
                num_car = len(self.cadena)
                act_car = 69  # numero de caracteres admitidos por cada linea
                num_lin = 1
                while act_car <= num_car:
                        while self.cadena[act_car] != ' ': # cada 69 caractreres del mensaje se introduce un salto de linea
                                act_car = act_car - 1
                        self.cadena = self.cadena[:act_car] + '\n' + self.cadena[act_car+1:]
                        num_lin = num_lin + 1
                        act_car = act_car + 70
                return num_lin

	# Constructor de la clase
	# Crea una ventana de aviso con el mensaje correspondiente
	# Paramentros de entrada:
	# - msg: mensaje que se va a publicar en el aviso
        def __init__(self, msg):
                self.PATH = '/usr/local/crv/'
                self.cadena = msg

		# Se prepara el mensaje de entrada para su publicacion
                self.indice_linea = self.preparar_mensaje()

                # Ventana del mensaje y contenedor
                self.warning_window = gtk.Window(gtk.WINDOW_TOPLEVEL)
                self.warning_window.set_position(gtk.WIN_POS_CENTER)
                self.warning_window.set_title("CRV - Aviso")
                self.warning_window.set_icon_from_file('%simg/crv_icon.png' % self.PATH)
                self.warning_window.set_border_width(10)
                self.warning_window.set_resizable(False)
                self.warning_window.connect("delete_event", self.delete_event)
                self.vbox = gtk.VBox(False, 30)
                self.panel = gtk.Fixed()
                self.vbox.pack_start(self.panel, True, True, 0)
                self.warning_window.add(self.vbox)


                # Cabecera de la ventana de aviso
                self.imagen_aviso = gtk.Image()
                self.imagen_aviso.set_from_file('%simg/warning.png' % self.PATH)
                self.panel.put(self.imagen_aviso, 130, 10)
                self.et_aviso = gtk.Label()
                self.et_aviso.set_markup("<b>Mensaje de aviso</b>")
                self.et_aviso.set_use_markup(True)
                self.panel.put(self.et_aviso, 190, 25)

                # Mensaje adaptado
                self.mensaje = gtk.Label()
                if msg != None:
                        self.mensaje.set_text("%s" % self.cadena)
                self.mensaje.set_justify(gtk.JUSTIFY_CENTER)
                self.panel.put(self.mensaje, 10, 70)


                # Botonera de la ventana
		# El mensaje es dinamico, tamano de la ventana y de la colocacacion de sus elementos
		# depende del numero de lineas del mensaje, indicado por la variable self.indice_linea
                self.boton = gtk.Button("Aceptar")
                self.boton.connect("clicked", self.delete_event, None)
                self.boton.set_size_request(90,30)
                altura_bot = 120 + (12*self.indice_linea)
                self.panel.put(self.boton, 400, altura_bot)


                # Dibujar la ventana de aviso
                altura = 160 + (12*self.indice_linea)
                self.warning_window.set_size_request(500, altura)
                self.imagen_aviso.show()
                self.et_aviso.show()
                self.mensaje.show()
                self.boton.show()
                self.panel.show()
                self.vbox.show()
                self.warning_window.show()

